package com.hua.valid;

import cn.hutool.core.util.StrUtil;
import com.hua.annotation.Handles;
import com.hua.valid.annotation.ConditionNotNull;
import org.springframework.expression.ExpressionParser;
import org.springframework.expression.spel.standard.SpelExpressionParser;

/**
 * @author Hua
 * @since 2024/7/18 下午2:43
 */
@Handles(ConditionNotNull.class)
public class ConditionNotNullHandler implements AnnotationHandler {
    @Override
    public boolean handle(HandleDTO handleDTO) {
        ConditionNotNull conditionValidate = (ConditionNotNull) handleDTO.getCurrentAnnotation();
        String test = conditionValidate.test();
        if (StrUtil.isEmpty(test)) {
            return true;
        }
        ExpressionParser parser = new SpelExpressionParser();

        Boolean value = parser.parseExpression(test).getValue(handleDTO.getOriginObj(), Boolean.class);
        if (Boolean.TRUE.equals(value) && handleDTO.getFieldValue() == null) {
            handleDTO.getErrorMessage().addErrorObj(conditionValidate.message(), handleDTO.getField());
            return false;
        }

        return true;
    }
}
