package com.hua.valid;

import java.lang.reflect.Field;
import java.util.ArrayList;
import java.util.List;
import java.util.stream.Collectors;

/**
 * @author Hua
 * @since 2024/7/18 下午2:43
 */
public class ErrorMessage {

    private final List<ErrorObj> listErrorObj = new ArrayList<>();

    public void addErrorObj(String errorMessage, Field errorField){
        ErrorObj errorObj = new ErrorObj(errorMessage, errorField);
        listErrorObj.add(errorObj);

    }

    public boolean isError() {
        return listErrorObj.size() > 0;
    }

    public String getErrorMessage(){
        return listErrorObj.stream().map(ErrorObj::getErrorMessage).collect(Collectors.joining(","));
    }


    public static class ErrorObj{
        private String errorMessage;

        private Field errorField;

        public ErrorObj(String errorMessage, Field errorField) {
            this.errorMessage = errorMessage;
            this.errorField = errorField;
        }

        public String getErrorMessage() {
            return errorMessage;
        }

        public void setErrorMessage(String errorMessage) {
            this.errorMessage = errorMessage;
        }

        public Field getErrorField() {
            return errorField;
        }

        public void setErrorField(Field errorField) {
            this.errorField = errorField;
        }
    }
}
