package com.hua.valid;

import java.lang.annotation.Annotation;
import java.lang.reflect.Field;

/**
 * @author Hua
 * @since 2024/7/18 下午2:43
 */
public class HandleDTO {

    /**
     * 要验证的实体类的原始值（有可能 实体类里面嵌套实体的情况）
     */
    private Object originObj;

    /**
     * 属性上加的所有的注解
     */
    private Annotation[] annotations;

    /**
     * 当前要处理的注解
     */
    private Annotation currentAnnotation;
    /**
     * 加注解的那个字段
     */
    private Field field;
    /**
     * 错误信息
     */
    private ErrorMessage errorMessage;
    /**
     * 加注解的那个字段值
     */
    private Object fieldValue;

    public Object getOriginObj() {
        return originObj;
    }

    public void setOriginObj(Object originObj) {
        this.originObj = originObj;
    }

    public Annotation[] getAnnotations() {
        return annotations;
    }

    public void setAnnotations(Annotation[] annotations) {
        this.annotations = annotations;
    }

    public Field getField() {
        return field;
    }

    public void setField(Field field) {
        this.field = field;
    }

    public ErrorMessage getErrorMessage() {
        return errorMessage;
    }

    public void setErrorMessage(ErrorMessage errorMessage) {
        this.errorMessage = errorMessage;
    }

    public Object getFieldValue() {
        return fieldValue;
    }

    public void setFieldValue(Object fieldValue) {
        this.fieldValue = fieldValue;
    }

    public Annotation getCurrentAnnotation() {
        return currentAnnotation;
    }

    public void setCurrentAnnotation(Annotation currentAnnotation) {
        this.currentAnnotation = currentAnnotation;
    }

    public static class HandleDTOBuilder {
        private final HandleDTO handleDTO;

        public HandleDTOBuilder() {
            handleDTO = new HandleDTO();
        }

        public HandleDTOBuilder setOriginObj(Object originObj) {
            handleDTO.setOriginObj(originObj);
            return this;
        }

        public HandleDTOBuilder setAnnotations(Annotation[] annotations) {
            handleDTO.setAnnotations(annotations);
            return this;
        }

        public HandleDTOBuilder setField(Field field) {
            handleDTO.setField(field);
            return this;
        }

        public HandleDTOBuilder setErrorMessage(ErrorMessage errorMessage) {
            handleDTO.setErrorMessage(errorMessage);
            return this;
        }

        public HandleDTOBuilder setFieldValue(Object fieldValue) {
            handleDTO.setFieldValue(fieldValue);
            return this;
        }

        public HandleDTOBuilder setCurrentAnnotation(Annotation currentAnnotation) {
            handleDTO.setCurrentAnnotation(currentAnnotation);
            return this;
        }

        public HandleDTO build() {
            return handleDTO;
        }
    }
}
